Codeforces 888E:Maximum Subsequence(枚举,二分)

You are given an array a consisting of n integers, and additionally an integer m. You have to choose some sequence of indices \(b_1,?b_2,?...,?b_k (1?≤?b_1?<?b_2?<?...?<?b_k?≤?n)\) in such a way that the value of \(\sum^{k}_{i=1}a_{b_i}\) is maximized. Chosen sequence can be empty.

Print the maximum possible value of \(\sum^{k}_{i=1}a_{b_i}\).

Input

The first line contains two integers \(n\) and \(m (1?≤?n?≤?35, 1?≤?m?≤?10^9)\).

The second line contains \(n\) integers \(a_1, a_2, ..., a_n (1?≤?a_i?≤?10^9)\).

Output

Print the maximum possible value of \(\sum^{k}_{i=1}a_{b_i}\).

Examples

Input

4 4

5 2 4 1

Output

3

Input

3 20

199 41 299

Output

19

Note

In the first example you can choose a sequence \(b?=?\{1,?2\}\), so the sum \(\sum^{k}_{i=1}a_{b_i}\) is equal to \(7\) (and that‘s \(3\) after taking it modulo \(4\)).

In the second example you can choose a sequence \(b?=?\{3\}\).

题意

给出\(n\)个数,从这\(n\)个数中选出几个数(可以不选),使得这些数的和对\(m\)取余后的值最大

思路

首先有一种特别暴力的方法:枚举出所有的状态后,找出对\(m\)取模后的最大值,时间复杂度\(O(2^n)\),这里\(n=35\),肯定是不行的

我们可以将这些数分成两段,分别枚举出这两段的所有状态,对左右两段排序,去重。然后从左半段中选出一个值\(value\),因为是对\(m\)取模后的最大值,所以最大的结果等于\(m-1\),在右半段利用二分查找大于\(m-1-value\)的位置\(place\),右半段\(place-1\)位置的数就是符合要求的数,相加取最大值即可

时间复杂度:\(O(2^{\left \lceil \dfrac {n}{2} \right \rceil}+n)\)

代码

#include <bits/stdc++.h>
#define ll long long
#define ull unsigned long long
#define ms(a,b) memset(a,b,sizeof(a))
const int inf=0x3f3f3f3f;
const ll INF=0x3f3f3f3f3f3f3f3f;
const int maxn=1e6+10;
const int mod=1e9+7;
const int maxm=1e3+10;
using namespace std;
int a[maxn];
int Left[maxn];
int Right[maxn];
int cntl,cntr;
int n,m;
int main(int argc, char const *argv[])
{
    #ifndef ONLINE_JUDGE
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        srand((unsigned int)time(NULL));
    #endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    for(int i=0;i<n;i++)
        cin>>a[i],a[i]%=m;
    int res=0;
    int l,r;
    l=r=n/2;
    for(int i=0;i<(1<<r);i++)
    {
        res=0;
        for(int j=0;j<r;j++)
            if(i>>j&1)
                res+=a[j],res%=m;
        Left[cntl++]=res;
    }
    res=0;
    r=n;
    int num=r-l+1;
    for(int i=0;i<(1<<num);i++)
    {
        res=0;
        for(int j=0;j<num;j++)
            if(i>>j&1)
                res+=a[l+j],res%=m;
        Right[cntr++]=res;
    }
    Left[cntl++]=0;
    Right[cntr++]=0;
    sort(Left,Left+cntl);
    sort(Right,Right+cntr);
    cntl=unique(Left,Left+cntl)-Left;
    cntr=unique(Right,Right+cntr)-Right;
    int ans=0;
    for(int i=0;i<cntl;i++)
    {
        int res=m-Left[i]-1;
        int pos=upper_bound(Right,Right+cntr,res)-Right;
        int num=Right[pos-1];
        ans=max(ans%m,(num+Left[i])%m);
    }
    cout<<ans<<endl;
    #ifndef ONLINE_JUDGE
        cerr<<"Time elapsed: "<<1.0*clock()/CLOCKS_PER_SEC<<" s."<<endl;
    #endif
    return 0;
}

原文地址:https://www.cnblogs.com/Friends-A/p/11569017.html

时间: 2024-09-29 19:55:02

Codeforces 888E:Maximum Subsequence(枚举,二分)的相关文章

Codeforces 484B Maximum Value(高效+二分)

题目链接:Codeforces 484B Maximum Value 题目大意:给定一个序列,找到连个数ai和aj,ai%aj尽量大,并且ai≥aj 解题思路:类似于素数筛选法的方式,每次枚举aj,然后枚举k,每次用二分找到小于k?aj并且最大的ai,维护答案,过程中加了一些剪枝. #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int maxn =

codeforces 880E. Maximum Subsequence(折半搜索+双指针)

E. Maximum Subsequence time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output You are given an array a consisting of n integers, and additionally an integer m. You have to choose some sequence of

Codeforces 496D Tennis Game 枚举+二分

题目链接:点击打开链接 题意: 给定n场比赛. 下面n个数字:表示该场是1获胜还是2获胜. 1.胜利者获得一分. 2.若已经决出整个赛季的胜负则比赛不会继续. 3.设要赢得这个赛季需要赢有s局,每局先获得t分的选手胜利. 问: 找出所有的(s,t)组合使得给定的n场比赛记录合法. 输出要排序. 枚举t. a数组存第一个人赢的哪些场次. b数组存第二个人赢的哪些场次. 设赢t分为一句.则判断 第一个人再赢t分是第几场,第二个人再赢t分是第几场. 显然先赢得t分的人赢了这场. 这样同时跑2个人的场数

CF 888E Maximum Subsequence

一道比较套路的题,看到数据范围就差不多有想法了吧. 题目大意:给一个数列和\(m\),在数列任选若干个数,使得他们的和对\(m\)取模后最大 取膜最大,好像不能DP/贪心/玄学乱搞啊.\(n\le35\)?果断meet in middle 考虑我们已经搜出了序列前一半的解,那么怎么根据后面的结果合并出结果? 设我们现在得到的和为\(x\)(对\(m\)取膜后),我们令一个数\(y=m-x\),然后在前面的解中查找\(y\)的前驱即可 接下来进行简单的证明: 若可以找到前驱\(z\),由于\(z<

Codeforces C. Maximum Value(枚举二分)

题目描述: Maximum Value time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output You are given a sequence a consisting of n integers. Find the maximum possible value of (integer remainder of *a**i* divi

Educational Codeforces Round 32 E. Maximum Subsequence

E. Maximum Subsequence 题意: n 个数,选出其中  k 个数,使得他们的和对 m 取模后最大. 输出这个最大值. tags:注意到 n 很小, 所以折半枚举. // E #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; +

【CF888E】Maximum Subsequence 折半搜索

[CF888E]Maximum Subsequence 题意:给你一个序列{ai},让你从中选出一个子序列,使得序列和%m最大. n<=35,m<=10^9 题解:不小心瞟了一眼tag就一下子知道怎么做了,吓得我赶紧把tag屏蔽了. 我们将原序列拆成两半,每一部分都暴力搜索出所有的子序列之和,用set存起来.然后枚举前一半的所有子序列和,设其为x,则使得总和%m最大的右半部分子序列和一定是所有<m-x的数中最大的那个,在set里找一下前驱就行了. #include <cstdio&

1007 Maximum Subsequence Sum(25 分)

1007 Maximum Subsequence Sum(25 分) Given a sequence of K integers { N?1??, N?2??, ..., N?K?? }. A continuous subsequence is defined to be { N?i??, N?i+1??, ..., N?j?? } where 1≤i≤j≤K. The Maximum Subsequence is the continuous subsequence which has th

CF888E Maximum Subsequence

CF888E Maximum Subsequence 有一种叫做折半搜索的好东西 我们把数列劈成两半,分别搜索,再合并 合并可以排序+二分或者排序+单调性 代码极短 #include<bits/stdc++.h> using namespace std; const int N=37; const int M=5000005; typedef long long ll; int n; ll m; ll a[N]; int mi; ll s1[M],s2[M]; int cnt1=0,cnt2=

Maximum Subsequence Sum - 最大子列和问题_C语言实现

第一次写这方面的blog.自己也是初次接触相关知识,写的有不妥的地方十分欢迎大家指正~ 这是浙大PAT上的一道算法题(据说是浙大04年研究生复试题),题目是这样的: Maximum Subsequence Sum Given a sequence of KK integers { N_1N?1??, N_2N?2??, ..., N_KN?K?? }. A continuous subsequence is defined to be { N_iN?i??, N_{i+1}N?i+1??, ..